package edu.lehigh.swat.vpi;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Organization: LU</p>
 * @author Z. Pan
 * @version 1.0
 */

public class AppFrame extends JFrame {
  JPanel contentPane;
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JTextField jTextField1 = new JTextField();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JButton jButton1 = new JButton();
  JLabel jLabel1 = new JLabel();
  JEditorPane jEditorPane1 = new JEditorPane();
  JButton jButton2 = new JButton();
  JLabel jLabel2 = new JLabel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JList jList1 = new JList();

  VPI vpi = new VPI();
  JButton jButton3 = new JButton();
  JScrollPane jScrollPane2 = new JScrollPane();
  JTextArea jTextArea1 = new JTextArea();

  //Construct the frame
  public AppFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(gridBagLayout1);
    this.setSize(new Dimension(600, 600));
    this.setTitle("VPI Application");
    jMenuFile.setText("File");
    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new AppFrame_jMenuFileExit_ActionAdapter(this));
    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new AppFrame_jMenuHelpAbout_ActionAdapter(this));
    jTextField1.setText("type in url here");
    jTextField1.setColumns(1);
    jButton1.setText("Load");
    jButton1.addActionListener(new AppFrame_jButton1_actionAdapter(this));
    jLabel1.setText("Loaded Documents");
    jEditorPane1.setText("input your RDQL query here");
    jButton2.setText("Query using VP");
    jButton2.addActionListener(new AppFrame_jButton2_actionAdapter(this));
    jLabel2.setText("Results");
    jButton3.setText("Query without VP");
    jButton3.addActionListener(new AppFrame_jButton3_actionAdapter(this));
    jTextArea1.setEditable(false);
    jTextArea1.setText("");
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    contentPane.add(jLabel1,                                           new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHEAST, GridBagConstraints.NONE, new Insets(8, 0, 51, 10), 0, 8));
    contentPane.add(jButton2,                                   new GridBagConstraints(1, 2, 2, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHEAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 10), 0, 0));
    contentPane.add(jEditorPane1,                                            new GridBagConstraints(0, 2, 1, 2, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 10, 10, 6), 25, 75));
    contentPane.add(jLabel2,                           new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHEAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 10), 0, 0));
    contentPane.add(jScrollPane1,                           new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(10, 10, 0, 0), 450, 36));
    contentPane.add(jTextField1,                    new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(10, 10, 0, 0), 400, 3));
    contentPane.add(jButton1,                 new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHEAST, GridBagConstraints.NONE, new Insets(10, 57, 0, 10), 0, 0));
    contentPane.add(jButton3,               new GridBagConstraints(1, 3, 2, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 10), 0, 0));
    contentPane.add(jScrollPane2,                  new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 0), 400, 200));
    jScrollPane2.getViewport().add(jTextArea1, null);
    jScrollPane1.getViewport().add(jList1, null);
    this.setJMenuBar(jMenuBar1);
  }
  //File | Exit action performed
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
  //Help | About action performed
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    AppFrame_AboutBox dlg = new AppFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  void jButton1_actionPerformed(ActionEvent e) {
    String url = jTextField1.getText();
    vpi.loadDocument(url);

    Object[] names = vpi.getLoadedDocuments();
    jList1.setListData(names);
  }

  void jButton2_actionPerformed(ActionEvent e) {
    String qs = jEditorPane1.getText();
    Query query = new Query(qs);
    ResultSet rs = vpi.issueQuery(query);
    jTextArea1.setText(rs.toString());
  }

  void jButton3_actionPerformed(ActionEvent e) {
    String qs = jEditorPane1.getText();
    Query query = new Query(qs);
    ResultSet rs = vpi.issueQueryWithoutVP(query);
    jTextArea1.setText(rs.toString());
  }
}

class AppFrame_jMenuFileExit_ActionAdapter implements ActionListener {
  AppFrame adaptee;

  AppFrame_jMenuFileExit_ActionAdapter(AppFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuFileExit_actionPerformed(e);
  }
}

class AppFrame_jMenuHelpAbout_ActionAdapter implements ActionListener {
  AppFrame adaptee;

  AppFrame_jMenuHelpAbout_ActionAdapter(AppFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuHelpAbout_actionPerformed(e);
  }
}

class AppFrame_jButton1_actionAdapter implements java.awt.event.ActionListener {
  AppFrame adaptee;

  AppFrame_jButton1_actionAdapter(AppFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}

class AppFrame_jButton2_actionAdapter implements java.awt.event.ActionListener {
  AppFrame adaptee;

  AppFrame_jButton2_actionAdapter(AppFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}

class AppFrame_jButton3_actionAdapter implements java.awt.event.ActionListener {
  AppFrame adaptee;

  AppFrame_jButton3_actionAdapter(AppFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton3_actionPerformed(e);
  }
}